Index: /matlab/testKF.m
===================================================================
--- /matlab/testKF.m (revision 22)
+++ /matlab/testKF.m (revision 32)
@@ -7,5 +7,5 @@
 	C=[1 0];
 	D=[0];
-	R=[0.1];
+	R=[1];
 	Q=[0.2 0 ; 0 0.02]; 
 
@@ -17,13 +17,14 @@
 	P0 = 200*eye(2);
 
-	u = ones(1,N);
+	u = zeros(1,N);
 	x = zeros(2,N);
 	y = zeros(1,N);
 
 	x(:,1) = [10;10];
+	Et = sQ*randn(2,N);
+	Wt = sR*randn(1,N);
 	for i=2:N;
-		et(1:2,i) = sQ*randn(2,1);
-		x(:,i) = A*x(:,i-1) + B*u(i) + et(:,i);
-		y(:,i) = C*x(:,i) + D*u(i) + sR*randn(1,1);
+		x(:,i) = A*x(:,i-1) + B*u(i) + Et(:,i);
+		y(:,i) = C*x(:,i) + D*u(i) + Wt(:,1);
 	end
 
@@ -39,4 +40,12 @@
 EP = [0;0];
 
+Oxt = mu0;
+OPt = P0;
+ll =0;
+Oxt2 = mu0;
+OPt2 = P0;
+ll2=0;
+
+
 for t=2:N
 	mu = A*mu + B*u(t);
@@ -50,5 +59,10 @@
 	mu = mu + K*(y(t)-C*mu-D*u(t));
 	Mu(1:2,t)=mu;
+
+	[Oxt,OPt,ll(t)] = Kalman(Oxt,y(t),A,C,Q,R,OPt);
+	[Oxt2,OPt2,ll2(t)] = Kalman(Oxt2,y(t),A,C,Q,R/10000,OPt2);
 end
+
+keyboard
 
 !cd ../;./tests/testKF
Index: /bdm/estim/libPF.h
===================================================================
--- /bdm/estim/libPF.h (revision 28)
+++ /bdm/estim/libPF.h (revision 32)
@@ -15,57 +15,164 @@
 
 #include <itpp/itbase.h>
-#include "../stat/libBM.h"
+#include "../stat/libEF.h"
 #include "../math/libDC.h"
 
 using namespace itpp;
 
-enum RESAMPLING_METHOD { MULTINOMIAL = 0, STRATIFIED = 1, SYSTEMATIC = 3 };
+/*!
+* \brief Trivial particle filter with proposal density equal to parameter evolution model.
 
-/*!
-* \brief A Particle Filter prototype
+Posterior density is represented by a weighted empirical density (\c eEmp ).
+*/
 
-Bayesian Filtering equations hold.
-*/
-class PF : public BM { 
+class PF : public BM {
 protected:
-	int n; //number of particles
-	vec w; //particle weights
-	Uniform_RNG URNG; //used for resampling
-	
+	//!number of particles;
+	int n;
+	//!posterior density
+	eEmp est;
+	//! pointer into \c eEmp
+	vec &_w;
+	//! pointer into \c eEmp
+	Array<vec> &_samples;
+	//! Parameter evolution model
+	mpdf &par;
+	//! Observation model
+	mpdf &obs;
 public:
-	//! Returns indexes of particles that should be resampled. The ordering MUST guarantee inplace replacement. (Important for MPF.)
-	ivec resample(RESAMPLING_METHOD method = SYSTEMATIC);
-	PF (vec w);
+	PF ( const RV &rv0, mpdf &par0,  mpdf &obs0, int n0 ) :BM ( rv0 ),
+			n ( n0 ),est ( rv0,n ),_w ( est._w() ),_samples ( est._samples() ),
+			par ( par0 ), obs ( obs0 ) {};
+
+//	void set_parametres(mpdf &par0, mpdf &obs0) {par=&par0;obs=&obs0;};
+	void set_est ( const epdf &epdf0 );
 	//TODO remove or implement bayes()!
-	void bayes(const vec &dt){};
-	epdf* _epdf(){return NULL;}
+	void bayes ( const vec &dt );
 };
 
 /*!
-* \brief Trivial particle filter with proposal density that is not conditioned on the data.
+\brief Marginalized Particle filter
 
-
+Trivial version: proposal $=$ parameter evolution, observation model is not used. (it is assumed to be part of BM).
 */
 
-class TrivialPF : public PF {
-	Array<vec> ptcls;
-	
-	bool is_proposal;
-	BM *prop;
-	mpdf *par;
-	mpdf *obs;
-	
+template<class BM_T>
+
+class MPF : public PF {
+	BM_T* Bms[1000];
+
+	//! internal class for MPDF providing composition of eEmp with external components
+
+class mpfepdf : public epdf  {
+	protected:
+		eEmp &E;
+		vec &_w;
+		Array<epdf*> Coms;
 	public:
-	TrivialPF(mpdf &par, mpdf &obs, BM &prop, int n0);
-	TrivialPF(mpdf &par, mpdf &obs, int n0);
-	void bayes(const vec &dt, bool evalll);
+		mpfepdf ( eEmp &E0, const RV &rvc ) :
+				epdf ( RV( ) ), E ( E0 ),  _w ( E._w() ),
+				Coms ( _w.length() ) {
+			rv.add ( E._rv() );
+			rv.add ( rvc );
+		};
+
+		void set_elements ( int &i, double wi, epdf* ep )
+		{_w ( i ) =wi; Coms ( i ) =ep;};
+
+		vec mean() const {
+			// ugly
+			vec pom=zeros ( ( Coms ( 0 )->_rv() ).count() );
+
+			for ( int i=0; i<_w.length(); i++ ) {pom += Coms ( i )->mean() * _w ( i );}
+
+			return concat ( E.mean(),pom );
+		}
+
+		vec sample() const {it_error ( "Not implemented" );return 0;}
+
+		double evalpdflog ( const vec &val ) const {it_error ( "not implemented" ); return 0.0;}
+	};
+
+	//! estimate joining PF.est with conditional
+	mpfepdf jest;
+
+public:
+	//! Default constructor.
+	MPF ( const RV &rvlin, const RV &rvpf, mpdf &par0, mpdf &obs0, int n, const BM_T &BMcond0 ) : PF ( rvpf ,par0,obs0,n ),jest ( est,rvlin ) {
+		//
+		//TODO test if rv and BMcond.rv are compatible.
+		rv.add ( rvlin );
+		//
+
+		if ( n>1000 ) it_error ( "increase 1000 here!" );
+
+		for ( int i=0;i<n;i++ ) {
+			Bms[i] = new BM_T ( BMcond0 ); //copy constructor
+			epdf& pom=Bms[i]->_epdf();
+			jest.set_elements ( i,1.0/n,&pom );
+		}
+	};
+
+	~MPF() {
+	}
+
+	void bayes ( const vec &dt );
+	epdf& _epdf() {return jest;}
+
+	void set_est ( const epdf& epdf0 ) {
+		PF::set_est ( epdf0 );  // sample params in condition
+		// copy conditions to BMs
+
+		for ( int i=0;i<n;i++ ) {Bms[i]->condition ( _samples ( i ) );}
+	}
 };
 
-class MPF : public TrivialPF {
-	Array<BM> Bms;
-	public:
-	MPF(BM &B, BM &prop, mpdf &obs, mpdf &par);
-	void bayes(vec &dt);	
-};
+template<class BM_T>
+void MPF<BM_T>::bayes ( const vec &dt ) {
+	int i;
+	vec lls ( n );
+	ivec ind;
+	double mlls=-std::numeric_limits<double>::infinity();
+	double sum=0.0;
+
+	for ( i=0;i<n;i++ ) {
+		//generate new samples from paramater evolution model;
+		_samples ( i ) = par.samplecond ( _samples ( i ), lls ( i ) );
+		Bms[i]->condition ( _samples ( i ) );
+		Bms[i]->bayes ( dt );
+		lls ( i ) += Bms[i]->_ll();
+
+		if ( lls ( i ) >mlls ) mlls=lls ( i ); //find maximum likelihood (for numerical stability)
+	}
+
+	// compute weights
+	for ( i=0;i<n;i++ ) {
+		_w ( i ) *= exp ( lls ( i ) - mlls ); // multiply w by likelihood
+	}
+
+	//renormalize
+	for ( i=0;i<n;i++ ) {sum+=_w ( i );};
+
+	_w /=sum; //?
+
+	if ( ( _w*_w ) < ( 0.5*n ) ) {
+		ind = est.resample();
+		// Resample Bms!
+
+		for ( i=0;i<n;i++ ) {
+			if ( ind ( i ) !=i ) {//replace the current Bm by a new one
+				//fixme this would require new assignment operator
+				// *Bms[i] = *Bms[ind ( i ) ];
+				
+				// poor-man's solution: replicate constructor here
+				// copied from MPF::MPF
+				delete Bms[i];
+				Bms[i] = new BM_T ( *Bms[ind ( i ) ] ); //copy constructor
+				epdf& pom=Bms[i]->_epdf();
+				jest.set_elements ( i,1.0/n,&pom );
+			}
+		};
+	}
+}
 
 #endif // KF_H
Index: /bdm/estim/libKF.cpp
===================================================================
--- /bdm/estim/libKF.cpp (revision 28)
+++ /bdm/estim/libKF.cpp (revision 32)
@@ -6,15 +6,15 @@
 using std::endl;
 
-KalmanFull::KalmanFull( mat A0, mat B0, mat C0, mat D0, mat R0, mat Q0, mat P0, vec mu0 ) {
+KalmanFull::KalmanFull ( mat A0, mat B0, mat C0, mat D0, mat R0, mat Q0, mat P0, vec mu0 ) {
 	dimx = A0.rows();
 	dimu = B0.cols();
 	dimy = C0.rows();
 
-	it_assert_debug( A0.cols()==dimx, "KalmanFull: A is not square" );
-	it_assert_debug( B0.rows()==dimx, "KalmanFull: B is not compatible" );
-	it_assert_debug( C0.cols()==dimx, "KalmanFull: C is not square" );
-	it_assert_debug(( D0.rows()==dimy ) || ( D0.cols()==dimu ),	"KalmanFull: D is not compatible" );
-	it_assert_debug(( R0.cols()==dimy ) || ( R0.rows()==dimy ), "KalmanFull: R is not compatible" );
-	it_assert_debug(( Q0.cols()==dimx ) || ( Q0.rows()==dimx ), "KalmanFull: Q is not compatible" );
+	it_assert_debug ( A0.cols() ==dimx, "KalmanFull: A is not square" );
+	it_assert_debug ( B0.rows() ==dimx, "KalmanFull: B is not compatible" );
+	it_assert_debug ( C0.cols() ==dimx, "KalmanFull: C is not square" );
+	it_assert_debug ( ( D0.rows() ==dimy ) || ( D0.cols() ==dimu ),	"KalmanFull: D is not compatible" );
+	it_assert_debug ( ( R0.cols() ==dimy ) || ( R0.rows() ==dimy ), "KalmanFull: R is not compatible" );
+	it_assert_debug ( ( Q0.cols() ==dimx ) || ( Q0.rows() ==dimx ), "KalmanFull: Q is not compatible" );
 
 	A = A0;
@@ -28,9 +28,9 @@
 }
 
-void KalmanFull::bayes( const vec &dt) {
-	it_assert_debug( dt.length()==( dimy+dimu ),"KalmanFull::bayes wrong size of dt" );
+void KalmanFull::bayes ( const vec &dt ) {
+	it_assert_debug ( dt.length() == ( dimy+dimu ),"KalmanFull::bayes wrong size of dt" );
 
-	vec u = dt.get( dimy,dimy+dimu-1 );
-	vec y = dt.get( 0,dimy-1 );
+	vec u = dt.get ( dimy,dimy+dimu-1 );
+	vec y = dt.get ( 0,dimy-1 );
 	//Time update
 	mu = A*mu + B*u;
@@ -39,8 +39,8 @@
 	//Data update
 	_Ry = C*P*C.transpose() + R;
-	_iRy = inv( _Ry );
-	_K = P*C.transpose()*_iRy;
+	_iRy = inv ( _Ry );
+	_K = P*C.transpose() *_iRy;
 	P -= _K*C*P; // P = P -KCP;
-	mu += _K*( y-C*mu-D*u );
+	mu += _K* ( y-C*mu-D*u );
 };
 
@@ -50,2 +50,14 @@
 }
 
+void KFcondQR::condition ( const vec &QR ) {
+	it_assert_debug ( QR.length() == ( rvc.count() ),"KFcondRQ: conditioning by incompatible vector" );
+
+	Q.setD ( QR ( 0, dimx-1 ));
+	R.setD ( QR ( dimx, -1 ));
+};
+
+void KFcondR::condition ( const vec &R0 ) {
+	it_assert_debug ( R0.length() == ( rvc.count() ),"KFcondR: conditioning by incompatible vector" );
+
+	R.setD ( R0 );
+};
Index: /bdm/estim/libKF.h
===================================================================
--- /bdm/estim/libKF.h (revision 28)
+++ /bdm/estim/libKF.h (revision 32)
@@ -24,12 +24,13 @@
 * \brief Basic Kalman filter with full matrices (education purpose only)! Will be deleted soon!
 */
-class KalmanFull : public BM { 
+
+class KalmanFull {
 	int dimx, dimy, dimu;
 	mat A, B, C, D, R, Q;
-	
-	//cache 
+
+	//cache
 	mat _Pp, _Ry, _iRy, _K;
 public:
-	//posterior 
+	//posterior
 	//! Mean value of the posterior density
 	vec mu;
@@ -38,9 +39,8 @@
 
 public:
-	//! Full constructor 
-	KalmanFull ( mat A, mat B, mat C, mat D, mat R, mat Q, mat P0, vec mu0);
+	//! Full constructor
+	KalmanFull ( mat A, mat B, mat C, mat D, mat R, mat Q, mat P0, vec mu0 );
 	//! Here dt = [yt;ut] of appropriate dimensions
-	void bayes(const vec &dt); 
-	epdf* _epdf(){return NULL;}; 
+	void bayes ( const vec &dt );
 
 	friend std::ostream &operator<< ( std::ostream &os, const KalmanFull &kf );
@@ -53,45 +53,58 @@
 */
 template<class sq_T>
-class Kalman : public BM { 
+
+class Kalman : public BM {
 protected:
+	RV rvy;
+	RV rvu;
 	int dimx, dimy, dimu;
 	mat A, B, C, D;
-	sq_T R, Q;
-	
-	//!posterior on $x_t$
+	sq_T Q,R;
+
+	//!posterior density on $x_t$
 	enorm<sq_T> est;
 	//!preditive density on $y_t$
 	enorm<sq_T> fy;
-	
+
 	mat _K;
 	//cache of fy
-	vec* _yp; 
+	vec* _yp;
 	sq_T* _Ry,*_iRy;
 	//cache of est
 	vec* _mu;
 	sq_T* _P, *_iP;
-	
+
 public:
 	//! Default constructor
-	Kalman (RV rvx0, RV rvy0, RV rvu0);
-	//! Set parameters with check of relevance 
-	void set_parameters (const mat &A0,const mat &B0,const mat &C0,const mat &D0,const sq_T &R0,const sq_T &Q0);
+	Kalman ( RV rvx0, RV rvy0, RV rvu0 );
+	//! Copy constructor
+	Kalman ( const Kalman<sq_T> &K0 );
+	//! Set parameters with check of relevance
+	void set_parameters ( const mat &A0,const mat &B0,const mat &C0,const mat &D0,const sq_T &R0,const sq_T &Q0 );
 	//! Set estimate values, used e.g. in initialization.
-	void set_est(const vec &mu0, const sq_T &P0 ){est.set_parameters(mu0,P0);};
+
+	void set_est ( const vec &mu0, const sq_T &P0 ) {
+		sq_T pom(dimy);
+		est.set_parameters ( mu0,P0 );
+		P0.mult_sym(C,pom);
+		fy.set_parameters ( C*mu0, pom );
+	};
+
 	//! Here dt = [yt;ut] of appropriate dimensions
-	void bayes(const vec &dt); 
+	void bayes ( const vec &dt );
+	epdf& _epdf() {return est;}
 
 //	friend std::ostream &operator<< ( std::ostream &os, const Kalman<sq_T> &kf );
 
 	//!access functions
-	enorm<sq_T>* _epdf(){return &est;} 
-};
-
-/*!
-\brief Extended Kalman Filter 
+};
+
+/*!
+\brief Extended Kalman Filter
 
 An approximation of the exact Bayesian filter with Gaussian noices and non-linear evolutions of their mean.
 */
 template<class sq_T>
+
 class EKF : public Kalman<ldmat> {
 	//! Internal Model f(x,u)
@@ -99,10 +112,34 @@
 	//! Observation Model h(x,u)
 	diffbifn* phxu;
-public:	
+public:
 	//! Default constructor
-	EKF (RV rvx, RV rvy, RV rvu);
-	void set_parameters(diffbifn* pfxu, diffbifn* phxu, const sq_T Q0, const sq_T R0);
+	EKF ( RV rvx, RV rvy, RV rvu );
+	void set_parameters ( diffbifn* pfxu, diffbifn* phxu, const sq_T Q0, const sq_T R0 );
 	//! Here dt = [yt;ut] of appropriate dimensions
-	void bayes(const vec &dt); 	
+	void bayes ( const vec &dt );
+};
+
+/*!
+\brief Kalman Filter with conditional diagonal matrices R and Q.
+*/
+
+class KFcondQR : public Kalman<ldmat>, public BMcond {
+//protected:
+public:
+	KFcondQR ( RV rvx, RV rvy, RV rvu, RV rvRQ ) : Kalman<ldmat> ( rvx, rvy,rvu ),BMcond ( rvRQ ) {};
+
+	void condition ( const vec &RQ );
+};
+
+/*!
+\brief Kalman Filter with conditional diagonal matrices R and Q.
+*/
+
+class KFcondR : public Kalman<ldmat>, public BMcond {
+//protected:
+public:
+	KFcondR ( RV rvx, RV rvy, RV rvu, RV rvR ) : Kalman<ldmat> ( rvx, rvy,rvu ),BMcond ( rvR ) {};
+
+	void condition ( const vec &R );
 };
 
@@ -110,25 +147,52 @@
 
 template<class sq_T>
-Kalman<sq_T>::Kalman(RV rvx, RV rvy, RV rvu): BM(),
-dimx(rvx.count()), dimy(rvy.count()),dimu(rvu.count()), 
- A(dimx,dimx), B(dimx,dimu), C(dimy,dimx), D(dimy,dimu), est(rvx), fy(rvy){
+Kalman<sq_T>::Kalman ( const Kalman<sq_T> &K0 ) : BM ( K0.rv ),rvy ( K0.rvy ),rvu ( K0.rvu ),
+		dimx ( rv.count() ), dimy ( rvy.count() ),dimu ( rvu.count() ),
+		A ( dimx,dimx ), B ( dimx,dimu ), C ( dimy,dimx ), D ( dimy,dimu ),est ( rv ), fy ( rvy ) {
+
+	this->set_parameters ( K0.A, K0.B, K0.C, K0.D, K0.R, K0.Q );
+
+//establish pointers
+	_mu = est._mu();
+	est._R ( _P,_iP );
+
+//fy
+	_yp = fy._mu();
+	fy._R ( _Ry,_iRy );
+
+//reset copy values in pointers
+	*_mu = *K0._mu;
+	*_P = *K0._P;
+	*_iP = *K0._iP;
+	*_yp = *K0._yp;
+	*_iRy = *K0._iRy;
+	*_Ry = *K0._Ry;
+
+}
+
+template<class sq_T>
+Kalman<sq_T>::Kalman ( RV rvx, RV rvy0, RV rvu0 ) : BM ( rvx ),rvy ( rvy0 ),rvu ( rvu0 ),
+		dimx ( rvx.count() ), dimy ( rvy.count() ),dimu ( rvu.count() ),
+		A ( dimx,dimx ), B ( dimx,dimu ), C ( dimy,dimx ), D ( dimy,dimu ),
+		Q(dimx), R (dimy),
+		est ( rvx ), fy ( rvy ) {
 //assign cache
 //est
-_mu = est._mu();
-est._R(_P,_iP);
+	_mu = est._mu();
+	est._R ( _P,_iP );
 
 //fy
-_yp = fy._mu();
-fy._R(_Ry,_iRy);
-};
-
-template<class sq_T>
-void Kalman<sq_T>::set_parameters(const mat &A0,const  mat &B0, const mat &C0, const mat &D0, const sq_T &R0, const sq_T &Q0) {
-	it_assert_debug( A0.cols()==dimx, "Kalman: A is not square" );
-	it_assert_debug( B0.rows()==dimx, "Kalman: B is not compatible" );
-	it_assert_debug( C0.cols()==dimx, "Kalman: C is not square" );
-	it_assert_debug(( D0.rows()==dimy ) || ( D0.cols()==dimu ),	"Kalman: D is not compatible" );
-	it_assert_debug(( R0.cols()==dimy ) || ( R0.rows()==dimy ), "Kalman: R is not compatible" );
-	it_assert_debug(( Q0.cols()==dimx ) || ( Q0.rows()==dimx ), "Kalman: Q is not compatible" );
+	_yp = fy._mu();
+	fy._R ( _Ry,_iRy );
+};
+
+template<class sq_T>
+void Kalman<sq_T>::set_parameters ( const mat &A0,const  mat &B0, const mat &C0, const mat &D0, const sq_T &R0, const sq_T &Q0 ) {
+	it_assert_debug ( A0.cols() ==dimx, "Kalman: A is not square" );
+	it_assert_debug ( B0.rows() ==dimx, "Kalman: B is not compatible" );
+	it_assert_debug ( C0.cols() ==dimx, "Kalman: C is not square" );
+	it_assert_debug ( ( D0.rows() ==dimy ) || ( D0.cols() ==dimu ),	"Kalman: D is not compatible" );
+	it_assert_debug ( ( R0.cols() ==dimy ) || ( R0.rows() ==dimy ), "Kalman: R is not compatible" );
+	it_assert_debug ( ( Q0.cols() ==dimx ) || ( Q0.rows() ==dimx ), "Kalman: Q is not compatible" );
 
 	A = A0;
@@ -137,38 +201,43 @@
 	D = D0;
 	R = R0;
-	Q = Q0;	
+	Q = Q0;
 }
 
 template<class sq_T>
-void Kalman<sq_T>::bayes( const vec &dt) {
-	it_assert_debug( dt.length()==( dimy+dimu ),"KalmanFull::bayes wrong size of dt" );
-
-	vec u = dt.get( dimy,dimy+dimu-1 );
-	vec y = dt.get( 0,dimy-1 );
+void Kalman<sq_T>::bayes ( const vec &dt ) {
+	it_assert_debug ( dt.length() == ( dimy+dimu ),"KalmanFull::bayes wrong size of dt" );
+
+	vec u = dt.get ( dimy,dimy+dimu-1 );
+	vec y = dt.get ( 0,dimy-1 );
 	//Time update
-	*_mu = A*(*_mu) + B*u;
+	*_mu = A* ( *_mu ) + B*u;
 	//P  = A*P*A.transpose() + Q; in sq_T
-	_P->mult_sym( A );
-	(*_P)+=Q;
+	_P->mult_sym ( A );
+	( *_P ) +=Q;
 
 	//Data update
 	//_Ry = C*P*C.transpose() + R; in sq_T
-	_P->mult_sym( C, *_Ry);
-	(*_Ry)+=R;
+	_P->mult_sym ( C, *_Ry );
+	( *_Ry ) +=R;
 
 	mat Pfull = _P->to_mat();
-	
-	_Ry->inv( *_iRy ); // result is in _iRy;
-	_K = Pfull*C.transpose()*(_iRy->to_mat());
-	
-	sq_T pom((int)Pfull.rows());
-	_iRy->mult_sym_t(C*Pfull,pom);
-	(*_P) -= pom; // P = P -PC'iRy*CP;
-	(*_yp) = C*(*_mu)+D*u; //y prediction
-	(*_mu) += _K*( y-(*_yp) );
-	
-	if (evalll==true) {
-		ll+=fy.evalpdflog(*_yp);
+
+	_Ry->inv ( *_iRy ); // result is in _iRy;
+	fy._cached ( true );
+	_K = Pfull*C.transpose() * ( _iRy->to_mat() );
+
+	sq_T pom ( ( int ) Pfull.rows() );
+	_iRy->mult_sym_t ( C*Pfull,pom );
+	( *_P ) -= pom; // P = P -PC'iRy*CP;
+	( *_yp ) = C* ( *_mu ) +D*u; //y prediction
+	( *_mu ) += _K* ( y- ( *_yp ) );
+
+
+	if ( evalll==true ) { //likelihood of observation y
+		ll=fy.evalpdflog ( y );
 	}
+
+//cout << "y: " << y-(*_yp) <<" R: " << _Ry->to_mat() << " iR: " << _iRy->to_mat() << " ll: " << ll <<endl;
+
 };
 
@@ -176,19 +245,19 @@
 
 template<class sq_T>
-EKF<sq_T>::EKF(RV rvx0, RV rvy0, RV rvu0): Kalman<ldmat>(rvx0,rvy0,rvu0){}
-
-template<class sq_T>
-void EKF<sq_T>::set_parameters(diffbifn* pfxu0,  diffbifn* phxu0,const sq_T Q0,const sq_T R0) {
-		pfxu = pfxu0;
-		phxu = phxu0;
-		
-		//initialize matrices A C, later, these will be only updated!
-		pfxu->dfdx_cond(*_mu,zeros(dimu),A,true);
-		pfxu->dfdu_cond(*_mu,zeros(dimu),B,true);
-		phxu->dfdx_cond(*_mu,zeros(dimu),C,true);
-		phxu->dfdu_cond(*_mu,zeros(dimu),D,true);
-
-		R = R0;
-		Q = Q0;
+EKF<sq_T>::EKF ( RV rvx0, RV rvy0, RV rvu0 ) : Kalman<ldmat> ( rvx0,rvy0,rvu0 ) {}
+
+template<class sq_T>
+void EKF<sq_T>::set_parameters ( diffbifn* pfxu0,  diffbifn* phxu0,const sq_T Q0,const sq_T R0 ) {
+	pfxu = pfxu0;
+	phxu = phxu0;
+
+	//initialize matrices A C, later, these will be only updated!
+	pfxu->dfdx_cond ( *_mu,zeros ( dimu ),A,true );
+	pfxu->dfdu_cond ( *_mu,zeros ( dimu ),B,true );
+	phxu->dfdx_cond ( *_mu,zeros ( dimu ),C,true );
+	phxu->dfdu_cond ( *_mu,zeros ( dimu ),D,true );
+
+	R = R0;
+	Q = Q0;
 
 	using std::cout;
@@ -201,32 +270,35 @@
 
 template<class sq_T>
-void EKF<sq_T>::bayes( const vec &dt) {
-	it_assert_debug( dt.length()==( dimy+dimu ),"KalmanFull::bayes wrong size of dt" );
-
-	vec u = dt.get( dimy,dimy+dimu-1 );
-	vec y = dt.get( 0,dimy-1 );
+void EKF<sq_T>::bayes ( const vec &dt ) {
+	it_assert_debug ( dt.length() == ( dimy+dimu ),"KalmanFull::bayes wrong size of dt" );
+
+	vec u = dt.get ( dimy,dimy+dimu-1 );
+	vec y = dt.get ( 0,dimy-1 );
 	//Time update
-	*_mu = pfxu->eval(*_mu, u);
-	pfxu->dfdx_cond(*_mu,u,A,false); //update A by a derivative of fx
-	
+	*_mu = pfxu->eval ( *_mu, u );
+	pfxu->dfdx_cond ( *_mu,u,A,false ); //update A by a derivative of fx
+
 	//P  = A*P*A.transpose() + Q; in sq_T
-	_P->mult_sym( A );
-	(*_P)+=Q;
+	_P->mult_sym ( A );
+	( *_P ) +=Q;
 
 	//Data update
-	phxu->dfdx_cond(*_mu,u,C,false); //update C by a derivative hx
+	phxu->dfdx_cond ( *_mu,u,C,false ); //update C by a derivative hx
 	//_Ry = C*P*C.transpose() + R; in sq_T
-	_P->mult_sym( C, *_Ry);
-	(*_Ry)+=R;
+	_P->mult_sym ( C, *_Ry );
+	( *_Ry ) +=R;
 
 	mat Pfull = _P->to_mat();
-	
-	_Ry->inv( *_iRy ); // result is in _iRy;
-	_K = Pfull*C.transpose()*(_iRy->to_mat());
-	(*_P) -= _K*C*Pfull; // P = P -KCP;
-	*_yp = phxu->eval(*_mu,u); //y prediction
-	(*_mu) += _K*( y-*_yp );
-	
-	if (evalll==true) {ll+=est.evalpdflog(y);}
+
+	_Ry->inv ( *_iRy ); // result is in _iRy;
+	_K = Pfull*C.transpose() * ( _iRy->to_mat() );
+
+	sq_T pom ( ( int ) Pfull.rows() );
+	_iRy->mult_sym_t ( C*Pfull,pom );
+	( *_P ) -= pom; // P = P -PC'iRy*CP;
+	*_yp = phxu->eval ( *_mu,u ); //y prediction
+	( *_mu ) += _K* ( y-*_yp );
+
+	if ( evalll==true ) {ll+=fy.evalpdflog ( y );}
 };
 
Index: /bdm/estim/libPF.cpp
===================================================================
--- /bdm/estim/libPF.cpp (revision 28)
+++ /bdm/estim/libPF.cpp (revision 32)
@@ -5,123 +5,40 @@
 using std::endl;
 
-PF::PF(vec w0){w=w0/sum(w0); n=w.length();}
 
-ivec PF::resample( RESAMPLING_METHOD method ) {
-	ivec ind=zeros_i( n );
-	ivec N_babies = zeros_i( n );
-	vec cumDist = cumsum( w );
-	vec u( n );
-	int i,j,parent;
-	double u0;
+void PF::bayes ( const vec &dt ) {
+	int i;
+	vec lls ( n );
+	ivec ind;
+	double mlls=-std::numeric_limits<double>::infinity(), sum=0.0;
 
-	switch ( method ) {
-	case MULTINOMIAL:
-		u( n - 1 ) = pow( URNG.sample(), 1.0 / n );
-		for ( i = n - 2;i >= 0;i-- ) {
-			u( i ) = u( i + 1 ) * pow( URNG.sample(), 1.0 / ( i + 1 ) );
-		}
-		break;
-	case STRATIFIED:
-		for ( i = 0;i < n;i++ ) {
-			u( i ) = ( i + URNG.sample() ) / n;
-		}
-		break;
-	case SYSTEMATIC:
-		u0 = URNG.sample();
-		for ( i = 0;i < n;i++ ) {
-			u( i ) = ( i + u0 ) / n;
-		}
-		break;
-	default:
-		it_error( "PF::resample(): Unknown resampling method" );
-	}
-	
-// 	// <<<<<<<<<<<
-// 	using std::cout;
-// 	cout << "resampling:" << endl;
-// 	cout << w <<endl;
-// 	cout << cumDist <<endl;
-// 	cout << u <<endl;
+	for ( i=0;i<n;i++ ) {
+		//generate new samples from paramater evolution model;
+		_samples ( i ) = par.samplecond ( _samples ( i ), lls ( i ) );
+		lls ( i ) *= obs.evalcond ( dt,_samples ( i ) );
 
-	// U is now full
-	j = 0;
-	for ( i = 0;i < n;i++ ) {
-		while ( u( i ) > cumDist( j ) ) j++;
-		N_babies( j )++;
+		if ( lls ( i ) >mlls ) mlls=lls ( i ); //find maximum
 	}
 
-// 	// <<<<<<<<<<<
-// 	cout << N_babies <<endl;
+	// compute weights
+	for ( i=0;i<n;i++ ) {
+		_w ( i ) *= exp ( lls ( i ) - mlls ); // multiply w by likelihood
+	}
 
-	// We have assigned new babies for each Particle
-	// Now, we fill the resulting index such that:
-	// * particles with at least one baby should not move *
-	// This assures that reassignment can be done inplace;
+	//renormalize
+	for ( i=0;i<n;i++ ) {sum+=_w ( i );};
 
-	// find the first parent;
-	parent=0; while(N_babies(parent)==0) parent++;
-	// Build index
-	for ( i = 0;i < n;i++ ) {
-		if ( N_babies( i ) > 0 ){
-			ind( i ) = i;
-			N_babies( i ) --; //this index was now replicated;
-			}
-		else {
-			// test if the parent has been fully replicated 
-			// if yes, find the next one
-			while((N_babies(parent)==0) || (N_babies(parent)==1 && parent>i) ) parent++;
-			// Replicate parent
-			ind (i) = parent;
-			N_babies( parent ) --; //this index was now replicated;
-		}
-/*			// <<<<<<<<<<<
-			cout <<ind << endl;*/
-	}
-	return ind;
+	_w ( i ) /=sum; //?
+
+	ind = est.resample();
+
 }
 
-TrivialPF::TrivialPF( mpdf &par0, mpdf &obs0, BM &prop0, int n0 ) : PF(1/n*ones(n)) {
-	is_proposal = true;
-	prop = &prop0;
-	par = &par0;
-	obs = &obs0;
-}
-TrivialPF::TrivialPF( mpdf &par0, mpdf &obs0,  int n0 ) : PF(1/n*ones(n)) {
-	is_proposal = false;
-	par = &par0;
-	obs = &obs0;
+void PF::set_est ( const epdf &epdf0 ) {
+	int i;
+
+	for ( i=0;i<n;i++ ) {
+		_samples ( i ) = epdf0.sample();
+	}
 }
 
-void TrivialPF::bayes( const vec &dt , bool evalll ) {
-	int i;
-	vec oldp;
-	double ll, gl, sum = 0.0;
-	Sort<double> S;
-	ivec ind, iw;
-	
-	//generate new samples
-	for ( i=0;i<n;i++ ) {
-		if(is_proposal) {
-			epdf* prop_epdf;
-	//		prop_epdf = prop._epdf();
-			prop->bayes(dt);
-			ptcls( i ) = prop_epdf->sample();
-			}
-//		gl = prop_cond.eval( ptcls( i ) );
-
-//		obs.evalcond( ptcls( i ), &obs_cond );
-//		ll = obs_cond.eval( dt );
-		w( i ) *= ll/gl;
-	}
-	//renormalize
-	for ( i=0;i<n;i++ ){sum+=w( i );};
-	w( i ) /=sum; //?
-	
-	ind = resample();
-	iw = S.sort_index( 0,n-1,w ); // the first one in iw is the strongest
-
-	for ( i=0;i<n;i++ ) {
-		ptcls( i ) = ptcls( i ); //potentionally dangerous!
-	}
-	
-}
+//MPF::MPF:{}
Index: /bdm/itpp_ext.h
===================================================================
--- /bdm/itpp_ext.h (revision 15)
+++ /bdm/itpp_ext.h (revision 32)
@@ -12,5 +12,44 @@
 #include <itpp/itbase.h>
 
+using std::cout;
+using std::endl;
+
 namespace itpp {
 	Array<int> to_Arr(const ivec &indices);
+	
+  /*!
+    \brief Gamma distribution
+    \ingroup randgen
+  */
+  class Gamma_RNG {
+  public:
+    //! constructor. Set lambda.
+    Gamma_RNG(double a=1.0, double b=1.0);
+    //! Set lambda
+    void setup(double a0, double b0) { alpha=a0; beta=b0;}
+    //! get lambda
+    double get_setup() const;
+    //! Get one sample.
+    double operator()() { return sample(); }
+    //! Get a sample vector.
+    vec operator()(int n);
+    //! Get a sample matrix.
+    mat operator()(int h, int w);
+  protected:
+  private:
+    //!
+    double sample();
+    //!
+    double alpha;
+    //!
+    double beta;
+    //!
+    Random_Generator RNG;
+    Normal_RNG NRNG;
+    //! compatibility with R
+    inline double exp_rand(){return -std::log(RNG.random_01());}
+    inline double unif_rand(){return RNG.random_01();}
+    inline double norm_rand(){return NRNG.sample();}
+
+  };
 }
Index: /bdm/math/libDC.h
===================================================================
--- /bdm/math/libDC.h (revision 28)
+++ /bdm/math/libDC.h (revision 32)
@@ -61,5 +61,5 @@
 		Used e.g. in generating normal samples.
 		*/
-		virtual vec sqrt_mult (const vec &v ) =0;
+		virtual vec sqrt_mult (const vec &v ) const =0;
 
 		/*!
@@ -67,5 +67,5 @@
 
 		*/
-		virtual double qform (const vec &v ) =0;
+		virtual double qform (const vec &v ) const =0;
 
 //	//! easy version of the
@@ -83,4 +83,6 @@
 		//! Destructor for future use;
 		virtual ~sqmat(){};
+		//! Default constructor
+		sqmat(const int dim0): dim(dim0){};
 	protected:
 		int dim;
@@ -101,6 +103,6 @@
 		void mult_sym ( const mat &C);
 		void mult_sym_t ( const mat &C);
-		void mult_sym ( const mat &C, fsqmat &U);
-		void mult_sym_t ( const mat &C, fsqmat &U);
+		void mult_sym ( const mat &C, fsqmat &U) const;
+		void mult_sym_t ( const mat &C, fsqmat &U) const;
 		void clear();
 
@@ -124,6 +126,6 @@
 
 		double logdet() const {return log ( det ( M ) );};
-		double qform (const  vec &v ) {return ( v* ( M*v ) );};
-		vec sqrt_mult (const vec &v ) {it_error ( "not implemented" );return v;};
+		double qform (const  vec &v ) const {return ( v* ( M*v ) );};
+		vec sqrt_mult (const vec &v ) const {it_error ( "not implemented" );return v;};
 
 		fsqmat& operator += ( const fsqmat &A ) {M+=A.M;return *this;};
@@ -132,5 +134,5 @@
 //		fsqmat& operator = ( const fsqmat &A) {M=A.M; return *this;};
 
-		friend std::ostream &operator<< ( std::ostream &os, fsqmat &sq );
+		friend std::ostream &operator<< ( std::ostream &os, const fsqmat &sq );
 
 };
@@ -162,10 +164,10 @@
 		void add ( const ldmat &ld2, double w=1.0 );
 		double logdet() const;
-		double qform (const vec &v );
+		double qform (const vec &v ) const;
 //	sqmat& operator -= ( const sqmat & ld2 );
 		void clear();
 		int cols() const;
 		int rows() const;
-		vec sqrt_mult ( const vec &v );
+		vec sqrt_mult ( const vec &v ) const;
 
 		/*! \brief Matrix inversion preserving the chosen form.
@@ -174,5 +176,5 @@
 
 		*/
-		virtual void inv ( ldmat &Inv );
+		virtual void inv ( ldmat &Inv ) const;
 
 		/*! \brief Symmetric multiplication of $U$ by a general matrix $C$, result of which is stored in the current class.
@@ -181,5 +183,5 @@
 
 		*/
-		void mult_sym ( const mat &C, ldmat &U);
+		void mult_sym ( const mat &C, ldmat &U) const;
 
 		/*! \brief Symmetric multiplication of $U$ by a transpose of a general matrix $C$, result of which is stored in the current class.
@@ -188,5 +190,5 @@
 
 		*/
-		void mult_sym_t ( const mat &C, ldmat &U);
+		void mult_sym_t ( const mat &C, ldmat &U) const;
 
 
@@ -200,4 +202,8 @@
 		*/
 		void ldform (const mat &A,const vec &D0 );
+
+		//! Access functions
+		void setD (const vec &nD){D=nD;}
+		void setL (const vec &nL){L=nL;}
 
 		ldmat& operator += ( const ldmat &ldA );
@@ -205,5 +211,6 @@
 		ldmat& operator *= ( double x );
 
-		friend std::ostream &operator<< ( std::ostream &os, ldmat &sq );
+		friend std::ostream &operator<< ( std::ostream &os, const ldmat &sq );
+
 
 	protected:
Index: /bdm/math/libDC.cpp
===================================================================
--- /bdm/math/libDC.cpp (revision 26)
+++ /bdm/math/libDC.cpp (revision 32)
@@ -17,19 +17,19 @@
 void fsqmat::mult_sym ( const mat &C) {M=C *M*C.T();};
 void fsqmat::mult_sym_t ( const mat &C) {M=C.T() *M*C;};
-void fsqmat::mult_sym ( const mat &C, fsqmat &U) { U.M = ( C *(M*C.T()) );};
-void fsqmat::mult_sym_t ( const mat &C, fsqmat &U) { U.M = ( C.T() *(M*C) );};
+void fsqmat::mult_sym ( const mat &C, fsqmat &U) const { U.M = ( C *(M*C.T()) );};
+void fsqmat::mult_sym_t ( const mat &C, fsqmat &U) const { U.M = ( C.T() *(M*C) );};
 void fsqmat::inv ( fsqmat &Inv ) {mat IM = itpp::inv ( M ); Inv=IM;};
 void fsqmat::clear() {M.clear();};
-fsqmat::fsqmat ( const mat &M0 )
+fsqmat::fsqmat ( const mat &M0 ) : sqmat(M0.cols())
 {
 	it_assert_debug ( ( M0.cols() ==M0.rows() ),"M0 must be square" );
-	M=M0;dim=M0.cols();
+	M=M0;
 };
 
-fsqmat::fsqmat() {};
-
-fsqmat::fsqmat(const int dim0): M(dim0,dim0) {};
-
-std::ostream &operator<< ( std::ostream &os,  fsqmat &ld ) {
+//fsqmat::fsqmat() {};
+
+fsqmat::fsqmat(const int dim0): sqmat(dim0), M(dim0,dim0) {};
+
+std::ostream &operator<< ( std::ostream &os, const fsqmat &ld ) {
 	os << ld.M << endl;
 	return os;
@@ -37,28 +37,21 @@
 
 
-ldmat::ldmat( const mat &exL, const vec &exD ) {
+ldmat::ldmat( const mat &exL, const vec &exD ) : sqmat(exD.length()) {
 	D = exD;
 	L = exL;
-	dim = exD.length();
-}
-
-ldmat::ldmat() {
-	dim = 0;
-}
-
-ldmat::ldmat(const int dim0): D(dim0),L(dim0,dim0) {
-	dim = dim0;
-}
-
-ldmat::ldmat(const vec D0) {
+}
+
+ldmat::ldmat() :sqmat(0) {}
+
+ldmat::ldmat(const int dim0): sqmat(dim0), D(dim0),L(dim0,dim0) {}
+
+ldmat::ldmat(const vec D0):sqmat(D0.length()) {
 	D = D0;
-	dim = D0.length();
 	L = eye(dim);
 }
 
-ldmat::ldmat( const mat &V ) {
+ldmat::ldmat( const mat &V ):sqmat(V.cols()) {
 //TODO check if correct!! Based on heuristic observation of lu()
 
-	dim = V.cols();
 	it_assert_debug( dim == V.rows(),"ldmat::ldmat matrix V is not square!" );
 		
@@ -86,5 +79,5 @@
 }
 
-std::ostream &operator<< ( std::ostream &os,  ldmat &ld ) {
+std::ostream &operator<< ( std::ostream &os, const ldmat &ld ) {
 	os << "L:" << ld.L << endl;
 	os << "D:" << ld.D << endl;
@@ -130,5 +123,5 @@
 void ldmat::clear(){L.clear(); for ( int i=0;i<L.cols();i++ ){L( i,i )=1;}; D.clear();}
 
-void ldmat::inv( ldmat &Inv ) {
+void ldmat::inv( ldmat &Inv ) const {
 	int dim = D.length();
 	Inv.clear();   //Inv = zero in LD
@@ -152,10 +145,10 @@
 }
 
-void ldmat::mult_sym( const mat &C, ldmat &U) {
+void ldmat::mult_sym( const mat &C, ldmat &U) const {
 	mat A=L*C.T(); //could be done more efficiently using BLAS
 	U.ldform(A,D);
 }
 
-void ldmat::mult_sym_t( const mat &C, ldmat &U) {
+void ldmat::mult_sym_t( const mat &C, ldmat &U) const {
 	mat A=L*C;
 /*	vec nD=zeros(U.rows());
@@ -173,5 +166,5 @@
 }
 
-double ldmat::qform( const vec &v ) {
+double ldmat::qform( const vec &v ) const {
 	double x = 0.0, sum;
 	int i,j;
@@ -179,5 +172,5 @@
 	for ( i=0; i<D.length(); i++ ) { //rows of L
 		sum = 0.0;
-		for ( j=0; j<=i; j++ ){sum+=L( i,j )*v( j );}
+		for ( j=i; j<=i; j++ ){sum+=L( i,j )*v( i );}
 		x +=D( i )*sum*sum;
 	};
@@ -191,5 +184,5 @@
 }
 
-vec ldmat::sqrt_mult( const vec &x ) {
+vec ldmat::sqrt_mult( const vec &x ) const {
 	int i,j;
 	vec res( dim );
@@ -383,4 +376,2 @@
 	}
 }
-
-
